#!/usr/bin/regina
/* Krip2clip.rex */
/* Version 1r4 */

trace off
parse ARG interpretedParsedArguments
ADDRESS SYSTEM 'echo $LANG' WITH OUTPUT STEM langList.
ADDRESS SYSTEM 'echo $INSTALLPATH' WITH OUTPUT STEM installList.
ADDRESS SYSTEM 'echo $HOME' WITH OUTPUT STEM homeList.

cr=x2c('0A')
tb=x2c('09')
qt=x2c('27')

/* say langList.1 */
/* say installList.1 */

labelError=''
labelWarn=''
labelVol=''

/* chaînes à traduire / strings to translate */
if index(langList.1,'fr')=1 then do
	labelChooseDVD='Sélection de la source'
	labelChooseDir='Choix de la destination'
	labelAnalyze='Analyse en cours'
	labelTitle='Titre '
	labelChapter='Chapître '
	labelSubttlOption='Sous-titres '
	labelAudioTrkOption='Pistes Audio '
	labelAc3Option='Encodage AC3 '
	labelHqOption='Encodage Haute Qualité (2 passes - lent)'
	labelContOption='Chapîtres contigus enchaînés'
	labelDuration='Durée '
	labelMin='min'
	labelSec='sec'
	labelChooseOptions='______________Choisissez parmi les options générales :______________'
	labelChooseOption1='Choisir la durée minimum d''un chapître (3 secondes par défaut)'
	labelChooseOption2='Sélectionner les chapîtres parmi ceux qui sont valides'
	labelChooseOption3='Accoler les chapîtres consécutifs choisis dans un même titre'
	labelChooseOption4='Forcer le mixage audio stéréo haute qualité'
	labelChooseOption5='Forcer l''encodage Vidéo Haute Qualité'
	labelChooseOption6='Choisir les sous-titres à inclure dans les videos clips'
	labelChooseOption7='Choisir les pistes audio possibles'
	labelMinDurChoice='Choisir la durée minimum d''un chapître (sec)'
	labelSubttlChoice='Choisir les sous-titres disponibles. 'cr'Note : seuls les sous-titres existant pour chaque 'cr'titre et correspondant au choix seront inclus'
	labelNoSubtitles='Pas de sous-titres'
	labelAudioTrkChoice='Choisr la piste audio. 'cr'Note : seules les pistes audio existantes pour chaque 'cr'titre et correspondant au choix seront incluses'
	labelNoAudioTracks='Pas de pistes audio'
	labelChaptersChoice='Choisir dans la liste des chapîtres présélectionnés de '
	labelChosenOptions='Options de traitement : '
	labelEndErrorRip='Impossible de ripper le DVD : vérifiez vos espaces disques' 
	labelEndErrorDvd='Impossible de ripper le DVD : vérifiez que la source est correcte' 
	labelEndExtract='Extraction terminée de ' 
	labelFiles='Les fichiers vidéos extraits du DVD sont les suivants :' 
	labelMeizuEncode='Voulez-vous encoder le résultat avec MeizuVideoEncoder ? ' 
	labelNetEncode='Voulez-vous encoder le résultat avec M.O.V.E. ? ' 
	labelKonqueror='Voulez-vous ouvrir le dossier de destination avec Konqueror ? ' 
	labelConfirm='Confirmez l''extraction de' 
	labelWarnAbend='Abandon !'
	labelWarnVolume='Le nom du DVD ne peut être extrait : saisissez-en un :'
	labelWarnService='Cette commande est un service menu : pour l''appeler depuis une ligne de commande ou un raccourci, n''entrez aucun paramètre'
	labelWarnCancel='Rien à ripper : abandon !'
	labelWarnOverride='Fichier(s) ignoré(s) :'
end
else do
	labelChooseDVD='Source selection'
	labelChooseDir='Destination selection'
	labelAnalyze='Analyzing, please wait'
	labelTitle='Title '
	labelChapter='Chapter '
	labelSubttlOption='Subtitles '
	labelAudioTrkOption='Audio Tracks '
	labelAc3Option='AC3 encoding'
	labelHqOption='High Quality encoding (2 pass - slow)'
	labelContOption='Contiguous chapters merged'
	labelDuration='Duration '
	labelMin='min'
	labelSec='sec'
	labelChooseOptions='____________________Select general option(s) :______________________'
	labelChooseOption1='Choose minimum duration of chapter(s) (default = 3 seconds)'
	labelChooseOption2='Select chapters in the list of valid chapters'
	labelChooseOption3='Merge contiguous chapters chosen within a same title'
	labelChooseOption4='Force high-quality stereo audio encoding'
	labelChooseOption5='Force High Quality Video encoding'
	labelChooseOption6='Choose subtitles to copy to target video clips'
	labelChooseOption7='Choose within all available audio tracks'
	labelMinDurChoice='Choose minimum duration of chapter(s) to select (sec)'
	labelSubttlChoice='Select subtitles. 'cr'Please note that only existing subtitles that 'cr'match your choice for a given title will be included'
	labelNoSubtitles='No subtitles'
	labelAudioTrkChoice='Select audio tracks. 'cr'Please note that only existing audio tracks that 'cr'match your choice for a given title will be included'
	labelNoAudioTracks='No audio tracks'
	labelChaptersChoice='Pick chapters in the list of selected chapters of '
	labelChosenOptions='Process options : '
	labelEndErrorRip='Rip impossible : check your disks spaces'
	labelEndErrorDvd='Rip impossible : check the source'
	labelEndExtract='Rip ended for ' 
	labelFiles='Video files extracted from DVD are :' 
	labelMeizuEncode='Do you want to encode resulting files with MeizuVideoEncoder ? '
	labelNetEncode='Do you want to encode resulting files with M.O.V.E. ? '
	labelKonqueror='Do you want to open target folder with Konqueror ? ' 
	labelConfirm='Confirm extraction of' 
	labelWarnAbend='Rip canceled !'
	labelWarnVolume='The name of the DVD can not be extract. Please, enter one :'
	labelWarnService='This command is a service menu action : please do not enter parameters if you call it by shortcut or command-line'
	labelWarnCancel='Nothing to rip : canceled !'
	labelWarnOverride='Target file(s) skipped :'
end


/* parseur de chaîne/arguments Kommander */
/* say interpretedParsedArguments */
interpretedParsedArguments=changestr('filename=',interpretedParsedArguments,'dvdname=')
if interpretedParsedArguments\='' & (index(interpretedParsedArguments,'dvdname='qt)=0 & lastpos(';',interpretedParsedArguments)\=length(interpretedParsedArguments)) then do
	labelWarn=labelWarnService
	signal WARNEND
end

p=1
if length(interpretedParsedArguments)>1024 then do
	interpretedParsedArgument.=''
	interpretedParsedArguments=interpretedParsedArguments' '
	do while lastpos(';',interpretedParsedArguments)\=0
		ip=index(interpretedParsedArguments,';')
		if ip>0 then do
			interpretedParsedArgument.p=substr(interpretedParsedArguments,1,ip)
			interpretedParsedArguments=substr(interpretedParsedArguments,ip+1)
		end
		p=p+1
	end
end    
else 	interpretedParsedArgument.1=interpretedParsedArguments


do t=1 to p
	lp=length(interpretedParsedArgument.t)
	if lp>1024 & index(interpretedParsedArgument.t,'dvdname=')=1 then do
		dvdname=translate(kmdrRexArgs(substr(interpretedParsedArgument.t,12,lp-13)),'  ',cr''tb)
		/*say dvdname */
	end
	else do
		interpret translate(kmdrRexArgs(interpretedParsedArgument.t),'  ',cr''tb)
	end
end

/* choix de la source */

if dvdname='' | dvdname='DVDNAME' then do
	dvdname=rexdialog('--icon 'installList.1'/'guicommand'_icon.png --miniicon 'installList.1'/'guicommand'_icon.png --title "'guicommand' 'versionNo' - 'labelChooseDVD'" --getopenfilename :label0 "media/dvdvideo inode/blockdevice application/x-iso" --separate-output')
	if dvdname='EXIT' | dvdname='ERROR' | dvdname='' then signal FORCEEXIT
end

/* choix du nom du volume si nécessaire */

volname=''
if substr(dvdname,1,14)='system:/media/' 	then dvdname='/dev/'substr(dvdname,15)
if substr(dvdname,1,7)='media:/'		then dvdname='/dev/'substr(dvdname,8)
if substr(dvdname,1,5)='/dev/' then do 
	ADDRESS SYSTEM 'volname 'dvdname WITH OUTPUT STEM volList.
	volname=volList.1
	do while volname='' | volname='VOLLIST.1'
		volname=rexdialog('--icon 'installList.1'/'guicommand'_icon.png --miniicon 'installList.1'/'guicommand'_icon.png --title "'guicommand' 'versionNo' - 'dvdname'" --inputbox "'LabelWarnVolume'"')
		if volname='EXIT' | volname='ERROR' | volname='' then signal FORCEEXIT
	end	
end

say labelAnalyze' 'dvdname' 'volname
if volname='' 	then labelVol=dvdname
		else labelVol=volname

dialogCode.1=rexdialog('--icon 'installList.1'/'guicommand'_icon.png --miniicon 'installList.1'/'guicommand'_icon.png --title "'guicommand' 'versionNo' - 'dvdname'" --progressbar "'labelAnalyze'" 100')


hbList.=''
'dcop "'dialogCode.1'" setProgress 50 & sleep 0.5'
ADDRESS SYSTEM 'HandBrakeCLI -i "'dvdname'" -o /dev/null -t 0 2>/tmp/hbList.txt' WITH OUTPUT STEM hbList.
if rc\=0 then do
	labelError=labelEndErrorDvd
	signal ERROR
end    
'dcop "'dialogCode.1'" setProgress 100'

imax=lines('/tmp/hbList.txt','C')

/* choix de la directory cible */

if destDir='' | destDir='DESTDIR' then do
	destDir=rexdialog('--icon 'installList.1'/'guicommand'_icon.png --miniicon 'installList.1'/'guicommand'_icon.png --title "'guicommand' 'versionNo' - 'labelChooseDir' - 'dvdname'" --getexistingdirectory :label1')
	if destDir='EXIT' | destDir='ERROR' | destDir='' then signal FORCEEXIT
end

/* mise en conformité nom de destination */
ls=lastpos('/',destDir)
if ls\=0 & ls\=length(destDir) then destDir=destDir'/' 

i=1
t=0
c=0
is=0
ia=0
title.=''
chapter.=''
duration.=''
seconds.=''
subtitle.=''
subtitles=''
audioTrack.=''
audioTracks=''
s=0
trace off
do i=1 to imax
	hbList.i=linein('/tmp/hbList.txt')
	if is\=0 then do
		iss=index(hbList.i,'+ ')
		do while iss>is
			st=substr(hbList.i,iss+2)
			if index(subtitles,st)=0 then subtitles=subtitles' "'st'"'		
			if index(subtitle.t,st)=0 then subtitle.t=subtitle.t' "'st'"'
			/* say ' - '
			say ' - '
			say 't='t 
			say 'subtitle.t='subtitle.t 
			say 'subtitles='subtitles 
			say 'st='st */
			i=i+1
			hbList.i=linein('/tmp/hbList.txt')
			iss=index(hbList.i,'+ ')
		end	
	end	
	if ia\=0 then do
		ias=index(hbList.i,'+ ')
		do while ias>ia
			at=substr(hbList.i,ias+2)
			if index(audioTracks,at)=0 then audioTracks=audioTracks' "'at'"'
			if index(audioTrack.t,at)=0 then audioTrack.t=audioTrack.t' "'at'"'
			/* say ' - '
			say ' - '
			say 't='t 
			say 'audioTrack.t='audioTrack.t 
			say 'audioTracks='audioTracks 
			say 'at='at */
			i=i+1
			hbList.i=linein('/tmp/hbList.txt')
			ias=index(hbList.i,'+ ')
		end	
	end
	if substr(hbList.i,1,7)='+ title' then do
		t=t+1
		title.t=substr(hbList.i,9,index(hbList.i,':')-9)
		c=0
		chapter.t.=''
		duration.t.=''
		subtitle.t=''
		audioTrack.t=''
		seconds.t=''
	end
	if index(hbList.i,': cells ')\=0 then do
		id=index(hbList.i,' duration ')
		if id\=0 then do
			secH=substr(hbList.i,id+10,2)*3600
			secM=substr(hbList.i,id+13,2)*60
			secS=substr(hbList.i,id+16,2)	
			c=c+1
			chapter.t.c=substr(hbList.i,7,index(hbList.i,':')-7)
			duration.t.c=substr(hbList.i,id+10,8)
			seconds.t.c=secH+secM+secS
		end
	end
	is=index(hbList.i,'+ subtitle tracks:')
        ia=index(hblist.i,'+ audio tracks:')
end
tmax=t
trace off
listItem6=''
if subtitles\='' then do
	listItem6='6 "'labelChooseOption6'" off'
end
listItem7=''
if audioTracks\='' then do
	listItem7='7 "'labelChooseOption7'" off'
end
/* choix des options d'encodage */
listOptions=rexdialog('--icon 'installList.1'/'guicommand'_icon.png --miniicon 'installList.1'/'guicommand'_icon.png --title "'guicommand' 'versionNo' - 'dvdname'" --separate-output --checklist "'labelChooseOptions'" 1 "'labelChooseOption1'" off 2 "'labelChooseOption2'" off 3 "'labelChooseOption3'" off 4 "'labelChooseOption4'" off 5 "'labelChooseOption5'" off 'listItem6' 'listItem7)
if listOptions='EXIT' | listOptions='ERROR' | listOptions=''  then signal FORCEEXIT
minDurChoice=0
titleChoice=0
mergeContiguous=0
chooseSubtl=0
chooseAudioTrk=0
/* audioOption='-6 stereo' */
audioOption='-E ac3'
subtlOption=''
hqOption=''
l=1

do words(listOptions)
	if word(listOptions,l)='1' then do
		minDurChoice=1
	end
	if word(listOptions,l)='2' then do 
		titleChoice=1
	end
	if word(listOptions,l)='3' then do 
		mergeContiguous=1
		labelChosenOptions=labelChosenOptions''cr' - 'labelContOption 
	end
	if word(listOptions,l)='4' then do 
		audioOption="-B 256 -6 stereo"
		labelChosenOptions=labelChosenOptions''cr' - 'labelAc3Option 
	end
	if word(listOptions,l)='5' then do 
		hqOption="-e x264 -b 1800 -f mkv -m -p -2 -T -x ref=3:mixed-refs:bframes=6:bime:weightb:b-rdo:direct=auto:b-pyramid:me=umh:subme=7:analyse=all:8x8dct:trellis=1:no-fast-pskip"
		labelChosenOptions=labelChosenOptions''cr' - 'labelHqOption
	end
	if word(listOptions,l)='6' then do 
		chooseSubtl=1
	end	
	if word(listOptions,l)='7' then do 
		chooseAudioTrk=1
	end	
	l=l+1
end

switch='off'
if minDurChoice then do
	minDur=rexdialog(' --icon 'installList.1'/'guicommand'_icon.png --miniicon 'installList.1'/'guicommand'_icon.png --title "'guicommand' 'versionNo' - 'dvdname'" --combobox "'labelMinDurChoice'" "3" "10" "15" "30" "45" "60" "120" --default "30"')
	if minDur='EXIT' | minDur='ERROR' then signal FORCEEXIT 
	if minDur\='' then do
		switch='on'
	end
end

if minDur='MINDUR' | minDur='' then minDur=3
labelChosenOptions=labelChosenOptions''cr' - 'labelDuration '>= 'minDur''labelSec 

ADDRESS SYSTEM 'dcop "'dialogCode.1'" close ' WITH OUTPUT STEM dcopLog.
/* say labelSubttlOption' 'chooseSubtl' 'subtitles */
if chooseSubtl then do
	if subtitles\='' then do
		pickedSubtl=rexdialog(' --icon 'installList.1'/'guicommand'_icon.png --miniicon 'installList.1'/'guicommand'_icon.png --title "'guicommand' 'versionNo' - 'dvdname'" --combobox "'labelSubttlChoice'" 'subtitles' "'labelNoSubtitles'"')
		if pickedSubtl='ERROR' | pickeSubtl='EXIT' then do
			labelWarn=labelWarnAbend
			signal WARNEND
		end
		else do
			if index(pickedSubtl,',')\=0 then do
				chosenSubtitle=pickedSubtl
				labelChosenOptions=labelChosenOptions''cr' - 'labelSubttlOption''chosenSubtitle	
			end	
		end

	end
	else do
		rc=rexdialog('--title "'guicommand' 'versionNo'" --msgbox "'labelNoSubtitles'"')
		if rc\=0 then do
			labelWarn=labelWarnAbend
			signal WARNEND
		end
	end
end
/* say labelAudioTrkOption' 'chooseAudioTrk' 'audioTracks */
if chooseAudioTrk then do
	if audioTracks\='' then do
		pickedAudioTrk=rexdialog(' --icon 'installList.1'/'guicommand'_icon.png --miniicon 'installList.1'/'guicommand'_icon.png --title "'guicommand' 'versionNo' - 'dvdname'" --combobox "'labelAudioTrkChoice'" 'audioTracks' "'labelNoAudioTracks'"')
		if pickedAudioTrk='ERROR' | pickeAudioTrk='EXIT' then do
			labelWarn=labelWarnAbend
			signal WARNEND
		end
		else do
			if index(pickedAudioTrk,',')\=0 then do
				chosenAudioTrack=pickedAudioTrk
				labelChosenOptions=labelChosenOptions''cr' - 'labelAudioTrkOption''chosenAudioTrack	
			end	
		end

	end
	else do
		rc=rexdialog('--title "'guicommand' 'versionNo'" --msgbox "'labelNoAdioTracks'"')
		if rc\=0 then do
			labelWarn=labelWarnAbend
			signal WARNEND
		end
	end
end
handbrakeFile=homeList.1'/krip2clipHandBrakeCommand.sh'
handbrakeCmds='#!/bin/bash'
listChosenChapters=''
prevChapt=''
prevTitle=''

listChapters=''
chosenChapter.=''
chosenTitle.=''
relativeTitle.=''
outputFilename=''
outputFilenames=''
c=1
do j=1 to tmax
	k=1		 
	do while chapter.j.k\=''
		if seconds.j.k>=minDur then do
			listChapters=listChapters' 'c' "'labelTitle''title.j' 'labelChapter''chapter.j.k' 'copies('=',3-length(chapter.j.k))'>    'labelDuration''duration.j.k'" 'switch
			chosenChapter.c=chapter.j.k
			chosenTitle.c=title.j
			relativeTitle.c=j
			c=c+1	
		end
		k=k+1
	end
end
chosenChaptersNum=c-1
l=1

if titleChoice then do
	/* choix des chapître */
	listChosenChapters=rexdialog('--icon 'installList.1'/'guicommand'_icon.png --miniicon 'installList.1'/'guicommand'_icon.png --title "'guicommand' 'versionNo' - 'dvdname'" --checklist "'labelChaptersChoice''cr''labelVol''cr''cr''labelChosenOptions'"'listChapters)
	if listChosenChapters='EXIT' | listChosenChapters='ERROR' then signal FORCEEXIT
	if listChosenChapters=0 then listChosenChapters=''
	listChosenChapters=translate(listChosenChapters,' ','"')
	chosenChaptersNum=words(listChosenChapters)
end
else do
	rc=rexdialog('--icon 'installList.1'/'guicommand'_icon.png --miniicon 'installList.1'/'guicommand'_icon.png --title "'guicommand' 'versionNo' - 'dvdname'" --yesno "'labelConfirm' 'labelVol''cr''labelChosenOptions'"')
	if rc\=0 then signal FORCEEXIT
	listChosenChapters=''
	do c=1 to chosenChaptersNum
		listChosenChapters=listChosenChapters' 'c
	end
end
trace off
do chosenChaptersNum
	c=word(listChosenChapters,l)
	t=relativeTitle.c
	if index(subtitle.t,chosenSubtitle)\=0 	then subtlOption='-s 'strip(translate(word(chosenSubtitle,1),' ',','))
						else subtlOption=''
	if index(audioTrack.t,chosenAudioTrack)\=0 	then audioTrkOption='-a 'strip(translate(word(chosenAudioTrack,1),' ',','))
							else audioTrkOption=''
	if c\='' then do
		lp=l+1
		if lp<=chosenChaptersNum then do
			cnext=word(listChosenChapters,lp)
			nextChapt=chosenChapter.cnext
			nextTitle=chosenTitle.cnext
		end
		else do
			nextChapt=''
			nextTitle=''
		end
		if mergeContiguous & ( prevChapt\=(chosenChapter.c)-1 | prevTitle\=chosenTitle.c ) then do
			firstContChapt=chosenChapter.c
		end
		if \mergeContiguous | ( nextChapt\=(chosenChapter.c)+1 | nextTitle\=chosenTitle.c ) then do
			if \mergeContiguous then do		
				cmd=hbCmd("dvdname='"dvdname"';volname='"volname"';destDir='"destDir"';title='"chosenTitle.c"';chapter='"chosenChapter.c"';audioOption='"audioOption"';subtlOption='"subtlOption"';audioTrkOption='"audioTrkOption"';")
				handbrakeCmds=handbrakeCmds''cr''cr'echo rip title='chosenTitle.c' chapter='chosenChapter.c''cr''cmd
			end
			else do
				if firstContChapt\=chosenChapter.c 	then chapts="chapter='"firstContChapt"-"chosenChapter.c"';"
									else chapts="chapter='"chosenChapter.c"';"
				cmd=hbCmd("dvdname='"dvdname"';volname='"volname"';destDir='"destDir"';title='"chosenTitle.c"';"chapts"audioOption='"audioOption"';subtlOption='"subtlOption"';audioTrkOption='"audioTrkOption"';")
				handbrakeCmds=handbrakeCmds''cr''cr'echo rip title='chosenTitle.c' 'chapts''cr''cmd
			end
			outputFilenames=outputFilenames' 'outputFilename
		end
		prevTitle=chosenTitle.c
		prevChapt=chosenChapter.c
	end
	l=l+1
end
trace off

/* say handbrakeCmds;signal FORCEEXIT */
if handbrakeCmds\='#!/bin/bash' then do

	fileString=changestr(' ',outputFilenames,'\\n')

	ADDRESS SYSTEM 'echo $(kde-config --expandvars --install data)' WITH OUTPUT STEM KDEPATH.
	ADDRESS SYSTEM 'du "'KDEPATH.1'/kmdr-M.O.V.E."' WITH OUTPUT STEM NetList.
	if rc=0 then do
		handbrakeCmds=handbrakeCmds''cr'rc=$(REXDIALOG --yesno 'changestr(' ',labelEndExtract''dvdname'\\n'labelNetEncode,'_')' --title 'changestr(' ',guicommand' 'versionNo,'_')' --noparse "_")'
		handbrakeCmds=handbrakeCmds''cr'if [ $rc = 0 ]; then'
		handbrakeCmds=handbrakeCmds''cr''tb'M.O.V.E. "filenames='qt''strip(outputFilenames)''qt';"'	
		handbrakeCmds=handbrakeCmds''cr'fi'
		handbrakeCmds=handbrakeCmds''cr'exit'
	end
	else do
		ADDRESS SYSTEM 'du "'KDEPATH.1'/kmdr-MeizuVideoEncoder"' WITH OUTPUT STEM MeizuList.
		if rc=0 then do
			handbrakeCmds=handbrakeCmds''cr'rc=$(REXDIALOG --yesno 'changestr(' ',labelEndExtract''dvdname'\\n'labelMeizuEncode,'_')' --title 'changestr(' ',guicommand' 'versionNo,'_')' --noparse "_")'
			handbrakeCmds=handbrakeCmds''cr'if [ $rc = 0 ]; then'
			handbrakeCmds=handbrakeCmds''cr''tb'MeizuVideoEncoder "filenames='qt''strip(outputFilenames)''qt';"'	
			handbrakeCmds=handbrakeCmds''cr'fi'
			handbrakeCmds=handbrakeCmds''cr'exit'
		end
		else do
			'konqueror -v'
			if rc=0 then do
				handbrakeCmds=handbrakeCmds''cr'rc=$(REXDIALOG --yesno 'changestr(' ',labelEndExtract''dvdname'\\n'labelKonqueror,'_')' --title 'changestr(' ',guicommand' 'versionNo,'_')' --noparse "_")'
				handbrakeCmds=handbrakeCmds''cr'if [ $rc = 0 ]; then'
				handbrakeCmds=handbrakeCmds''cr''tb'konqueror "'destDir'"'	
				handbrakeCmds=handbrakeCmds''cr'fi'
				handbrakeCmds=handbrakeCmds''cr'exit'
			end
			else do
				handbrakeCmds=handbrakeCmds''cr'REXDIALOG --msgbox 'changestr(' ',labelEndExtract''dvdname'\\n'labelFiles'\\n'fileString,'_')' --title 'changestr(' ',guicommand' 'versionNo,'_')' --noparse "_"'
			end
		end
	end
	rc=lineout(handbrakeFile,handbrakeCmds,1)
	'chmod 755 'handbrakeFile
	'konsole -v'
	if rc\=0 	then 'gnome-terminal -e 'handBrakeFile
			else 'konsole -e 'handbrakeFile
end
else do
	labelWarn=labelWarnCancel
	signal WARNEND
end    

signal FORCEEXIT
return

hbCmd:
PARSE ARG interpretedParsedArguments

interpret kmdrRexArgs(interpretedParsedArguments)	
destDir=substr(destDir,1,lastpos('/',destDir))			
lastPosSlash=lastpos('/',dvdname)
if volname='' then do
	if lastPosSlash\=0			then outputFilename=destDir''substr(dvdname,lastPosSlash+1)
						else outputFilename=dvdname
end
else outputFilename=destDir''volname
if chapter\='CHAPTER' 	then do
	outputFilename=changeExtDVDAvi('"'outputFilename'"' title chapter)
	cmd='HandBrakeCLI -i "'dvdname'" -o "'outputfilename'" -t 'title' -c 'chapter' 'audioOption' 'subtlOption' 'audioTrkOption' 'hqOption
end
else do
	outputFilename=changeExtDVDAvi('"'outputFilename'"' title)
	cmd='HandBrakeCLI -i "'dvdname'" -o "'outputfilename'" -t 'title' 'audioOption' 'subtlOption' 'audioTrkOption' 'hqOption
end
return cmd

changeExtDVDAvi:
PARSE ARG '"' videoFilename '"' vtitle vchapter
/* say vtitle vchapter */
exts='.mov .qt .mpeg .ra .vdo .viv .xvid .bup .ifo .vob .mpg .iso'
do w=1 to words(exts)
	videoFilename=changestr(word(exts,w),videoFilename,'.avi')
	videoFilename=changestr(word(UPPER(exts),w),videoFilename,'.avi')
end
videoFilename=videoFilename'.avi'
videoFilename=changestr('.avi.avi',videoFilename,'.avi')

if vchapter='' 	then do
	lchapter=''
end
else do
	ic=index(vchapter,'-')
	if ic\=0 then do
		lchapter='_C'right(substr(vchapter,1,ic-1),2,'0')'-'right(substr(vchapter,ic+1),2,'0')
	end
	else do
		lchapter='_C'right(vchapter,2,'0')
	end
end

videoFilename=changestr('.avi',videoFilename,'_T'right(vtitle,2,'0')''lchapter'.avi')
return videoFilename

ERROR:
ADDRESS SYSTEM 'dcop "'dialogCode.1'" close ' WITH OUTPUT STEM dcopLog.
varrex=rexdialog('--title "'guicommand' 'versionNo'" --sorry "'labelError'"')
'killall HandBrakeCLI'
exit


FORCEEXIT:
ADDRESS SYSTEM 'dcop "'dialogCode.1'" close ' WITH OUTPUT STEM dcopLog.
'killall HandBrakeCLI'
exit

WARNEND:
if guicommand='GUICOMMAND' then guicommand='Service menu'
if versionNo='VERSIONNO' then versionNo=''
ADDRESS SYSTEM 'dcop "'dialogCode.1'" close ' WITH OUTPUT STEM dcopLog.
varrex=rexdialog('--title "'guicommand' 'versionNo'" --msgbox "'labelWarn'"')
'killall HandBrakeCLI'
exit


WARNCONTINUE:
varrex=rexdialog('--title "'guicommand' 'versionNo'" --msgbox "'labelWarn'"')
return
